#include "StdAfx.h"
#include "Acm.h"

CAcm::CAcm() 

{
	m_pAudioFile = new CAudioFile();
	m_pOutputFile = 0;
	m_psSource = 0;
	m_psDest = 0;
	m_Bitrate = 48000;	
	m_bEnd = FALSE;
}

CAcm::~CAcm()

{
	delete m_pAudioFile;
}

long CAcm::Open(wchar_t* pcDstFileName, wchar_t* pcSrcFileName, 
				HWND hwndEvent, UINT msg)
{	
	m_hwndEvent = hwndEvent;
	m_msg = msg;
	m_pAudioFile->Open(pcSrcFileName);
	_wfopen_s(&m_pOutputFile, pcDstFileName, L"wb");
	m_WaveFormatDest.wfx.wFormatTag = WAVE_FORMAT_MPEGLAYER3;
	m_WaveFormatDest.wfx.nSamplesPerSec = m_pAudioFile->m_wfx.nSamplesPerSec;  
	m_WaveFormatDest.wfx.wBitsPerSample = 0;
	m_WaveFormatDest.wfx.nChannels = m_pAudioFile->m_wfx.nChannels;	
	m_WaveFormatDest.wfx.nBlockAlign = 1;
	m_WaveFormatDest.wfx.nAvgBytesPerSec = m_Bitrate / 8; 
	m_WaveFormatDest.wfx.cbSize = MPEGLAYER3_WFX_EXTRA_BYTES;
	m_WaveFormatDest.fdwFlags = MPEGLAYER3_FLAG_PADDING_OFF;
	m_WaveFormatDest.nBlockSize = 72 * m_Bitrate / m_pAudioFile->m_wfx.nSamplesPerSec;  
	m_WaveFormatDest.nFramesPerBlock = 1;                     
	m_WaveFormatDest.nCodecDelay = 0;                      
	m_WaveFormatDest.wID = MPEGLAYER3_ID_MPEG;
	m_sourceSize = 1152 * 10 * m_pAudioFile->m_wfx.wBitsPerSample / 8;
	m_destSize = 10 * 72 * m_pAudioFile->m_wfx.nChannels * m_Bitrate / m_pAudioFile->m_wfx.nSamplesPerSec + 3840;
	m_psSource = (short*)malloc(m_sourceSize);
	m_psDest = (short*)malloc(m_destSize);
	m_NumberOfConversions = m_pAudioFile->m_lAudioDataLength / m_sourceSize;
	MMRESULT mr;
	mr = acmStreamOpen(&m_hStream, NULL, &m_pAudioFile->m_wfx, (WAVEFORMATEX*)&m_WaveFormatDest, NULL, NULL, NULL, 0);
	return mr;
}

int CAcm::Convert()
{
   m_bEnd = FALSE;
   SendMessage(m_hwndEvent, m_msg, 0, 0);
   ACMSTREAMHEADER StreamHeader;
   DWORD cbDstLengthUsed = 0;
   memset(&StreamHeader, 0, sizeof(ACMSTREAMHEADER));
   StreamHeader.cbStruct = sizeof(ACMSTREAMHEADER);
   for(int i = 0; i < m_NumberOfConversions; i++) {
      m_pAudioFile->Read(m_psSource, m_sourceSize);
      StreamHeader.pbSrc = (PBYTE)m_psSource;
      StreamHeader.cbSrcLength = m_sourceSize;
      StreamHeader.pbDst = (PBYTE)m_psDest;
      StreamHeader.cbDstLength = m_destSize;   
      acmStreamPrepareHeader(m_hStream, &StreamHeader, 0);
      acmStreamConvert(m_hStream, &StreamHeader, ACM_STREAMCONVERTF_BLOCKALIGN);
      cbDstLengthUsed = StreamHeader.cbDstLengthUsed;
      acmStreamUnprepareHeader(m_hStream, &StreamHeader, 0);
	  fwrite(m_psDest, 1, cbDstLengthUsed, m_pOutputFile);
   }
   m_bEnd = TRUE;
   SendMessage(m_hwndEvent, m_msg, 0, 0);
   return cbDstLengthUsed;
}

void CAcm::Close()
{
   acmStreamClose(m_hStream, 0); 
   m_pAudioFile->Close();
   if(m_pOutputFile){
      fclose(m_pOutputFile);
	  m_pOutputFile = 0;
   }
   if(m_psSource){
      free(m_psSource);
	  m_psSource = 0;
   }
   if(m_psDest){
      free(m_psDest);
	  m_psDest = 0;
   }
}

void CAcm::HandleEvent(BOOL* bEnd)

{
	*bEnd = m_bEnd;
}