#include "StdAfx.h"
#include "AudioFile.h"
#include "stdio.h"
#include "io.h"

CAudioFile::CAudioFile(void)
{
	m_pFile = 0;
	m_lAudioDataLength = 0;
}

CAudioFile::~CAudioFile(void)
{
	Close();
}

int CAudioFile::Open(wchar_t* pcFileName)

{
	errno_t ret = _wfopen_s(&m_pFile, pcFileName, L"rb");
	if(!m_pFile)
		return -1;
	int fh = _fileno(m_pFile);
	m_lFileLength = _filelength(fh);
	ReadWaveHeader();
	return 0;
}

void CAudioFile:: Close()

{
	if(m_pFile) 
		fclose(m_pFile);
	m_pFile = 0;
	m_lAudioDataLength = 0;
}

int CAudioFile::Read(short* pcBuffer, long length)

{
	return fread(pcBuffer, 1, length, m_pFile);
}


void CAudioFile::ReadWaveHeader()

{	
	if(!m_pFile)
		return;	
	// WAVEFORMATEX lesen:
    long nBlockLength= FindChunk("fmt ");
	fread(&m_wfx, sizeof(WAVEFORMATEX), 1, m_pFile);	
	m_lAudioDataLength = FindChunk("data");

}

long CAudioFile::FindChunk(char* pcChunk)

{	
	long searchChunk;
	memcpy(&searchChunk, pcChunk, 4);
	long search;
	int i;
	int len = 0;
	fseek(m_pFile, 0, SEEK_SET);
	for(i = 0; i < m_lFileLength - 4; i++) {
		fread(&search, 4, 1, m_pFile);	
		if(search == searchChunk) {
			// Lnge des Chunks lesen
			fread(&len, 4, 1, m_pFile);	
			break;
		}
		fseek(m_pFile, -3, SEEK_CUR);					
	}	
	return len;
}