#include "StdAfx.h"
#include "LameCodec.h"

CLame::CLame() 

{
	m_pAudioFile = new CAudioFile();
	m_pOutputFile = 0;
	m_psSource = 0;
	m_psDest = 0;
	m_Bitrate = 128000;	
	m_bEnd = FALSE;
	m_lame_global_flags = 0;	
}

CLame::~CLame()

{
	delete m_pAudioFile;
}

long CLame::Open(wchar_t* pcDstFileName, wchar_t* pcSrcFileName,
				 HWND hwndEvent, UINT msg)
{
   m_hwndEvent = hwndEvent;
   m_msg = msg;
   m_pAudioFile->Open(pcSrcFileName);
   _wfopen_s(&m_pOutputFile, pcDstFileName, L"wb");
   m_sourceSize = 1152 * 10;
   m_destSize = 10 * 144 * m_pAudioFile->m_wfx.nChannels * m_Bitrate / m_pAudioFile->m_wfx.nSamplesPerSec + 7200;
   m_psSource = (short*)malloc(m_sourceSize);
   m_psDest = (short*)malloc(m_destSize);
   m_NumberOfConversions = m_pAudioFile->m_lAudioDataLength / m_sourceSize;
   m_lame_global_flags = lame_init();	
   lame_set_num_channels(m_lame_global_flags, m_pAudioFile->m_wfx.nChannels);
   lame_set_in_samplerate(m_lame_global_flags, m_pAudioFile->m_wfx.nSamplesPerSec);
   lame_set_out_samplerate(m_lame_global_flags, m_pAudioFile->m_wfx.nSamplesPerSec);
   lame_set_brate(m_lame_global_flags, m_Bitrate / 1000);
   lame_init_params(m_lame_global_flags);
   m_bEncode = TRUE;
   return 0;
}
int CLame::Convert()
{
   int byteCount;
   m_bEnd = FALSE;
   SendMessage(m_hwndEvent, m_msg, 0, 0);
   WORD nBlockAlign = m_pAudioFile->m_wfx.nBlockAlign;
   for(int i = 0; i < m_NumberOfConversions; i++) {
      m_pAudioFile->Read(m_psSource, m_sourceSize);
	  if(m_bEncode == TRUE)
         byteCount =lame_encode_buffer_interleaved(m_lame_global_flags, m_psSource, m_sourceSize / nBlockAlign, 
		                                           (PBYTE)m_psDest, (int)(1.25 * m_sourceSize / nBlockAlign + 7200));			
      else
         byteCount = lame_decode1((PBYTE)m_psSource, m_sourceSize, m_psDest, 0);
	  fwrite(m_psDest, 1, byteCount, m_pOutputFile);
   }
   m_bEnd = TRUE;
   SendMessage(m_hwndEvent, m_msg, 0, 0);
   return 0;
}

void CLame::Close()
{
	if(m_lame_global_flags) {
		lame_close(m_lame_global_flags);
		m_lame_global_flags = 0;
	}
	m_pAudioFile->Close();
	if(m_pOutputFile){
      fclose(m_pOutputFile);
	  m_pOutputFile = 0;
   }
   if(m_psSource){
      free(m_psSource);
	  m_psSource = 0;
   }
   if(m_psDest){
      free(m_psDest);
	  m_psDest = 0;
   }
}

void CLame::HandleEvent(BOOL* bEnd)

{
   *bEnd = m_bEnd;
}