// MP3Konverter.cpp : Definiert den Einstiegspunkt fr die Anwendung.
//

#include "stdafx.h"
#include "MP3Konverter.h"
#include "CodecCreator.h"
#include "CommDlg.h"

#define MAX_LOADSTRING 100
const UINT WM_CODEC_EVENT = WM_APP + 1;
const UINT WM_START_CONVERSION = WM_APP + 2;
// Globale Variablen:
HINSTANCE hInst;								// Aktuelle Instanz
TCHAR szTitle[MAX_LOADSTRING];					// Titelleistentext
TCHAR szWindowClass[MAX_LOADSTRING];			// Klassenname des Hauptfensters
wchar_t pcDestFileName[512];
wchar_t pcSourceFileName[512];
	

// Vorwrtsdeklarationen der in diesem Codemodul enthaltenen Funktionen:
//ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Hier Code einfgen.
	MSG msg;
	HACCEL hAccelTable;

	// Globale Zeichenfolgen initialisieren
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MP3KONVERTER, szWindowClass, MAX_LOADSTRING);
	//MyRegisterClass(hInstance);

	// Anwendungsinitialisierung ausfhren:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MP3KONVERTER));

	// Hauptnachrichtenschleife:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return (int) msg.wParam;
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Instanzenhandle in der globalen Variablen speichern
   hWnd = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAINBOX), 0, (DLGPROC)WndProc);
   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void OpenFileDialog(wchar_t* pcFileName, wchar_t* pcTitle)

{
	OPENFILENAME ofn;
    wchar_t szFile[260]; 
	
    szFile[0] = 0;
   
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = NULL;
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = L"Audiodateien(*.wav;*.mp3)\0*.WAV;*.MP3\0";
    ofn.nFilterIndex = 1;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = L"Debug";
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrTitle = pcTitle;
	if (GetOpenFileName(&ofn) == TRUE)		
		memcpy(pcFileName, szFile, 260);				

}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CCodecCreator* pCodecCreator = new CCodecCreator(); 
	static ICodec* pCodec;
	BOOL bEnd;
	
	switch (message){
		case WM_INITDIALOG:
			SendMessage(GetDlgItem(hWnd, IDC_ACM),BM_SETCHECK, BST_CHECKED, 0);
			pCodecCreator->getObject(IDC_ACM, &pCodec);
			return TRUE;
		case WM_COMMAND:			
			switch(LOWORD(wParam)){
				case IDCANCEL:
					pCodec->Close();					
					EndDialog(hWnd, LOWORD(wParam));
					PostQuitMessage(0);
					return TRUE;
				case IDB_OPEN:
					pCodec->Close();
					OpenFileDialog(pcSourceFileName, L"Quelldatei auswhlen");
					OpenFileDialog(pcDestFileName, L"Zieldatei auswhlen");
					pCodec->Open(pcDestFileName, pcSourceFileName, hWnd, WM_CODEC_EVENT);
					OutputDebugString(L"ffnen\n");
					break;
				case IDB_CONVERT:					
					pCodec->Convert();					
					OutputDebugString(L"Konvertieren\n");
					break;
				case IDB_CLOSE:
					pCodec->Close();
					break;
				case IDC_ACM:
					pCodecCreator->getObject(IDC_ACM, &pCodec);
					OutputDebugString(L"ACM\n");
					break;
				case IDC_LAME:
					pCodecCreator->getObject(IDC_LAME, &pCodec);
					OutputDebugString(L"Lame\n");
					break;
				case IDC_DIRECTSHOW:
					pCodecCreator->getObject(IDC_DIRECTSHOW, &pCodec);
					OutputDebugString(L"DirectShow\n");
					break;
			}		
			break;
		case WM_CODEC_EVENT:
			OutputDebugString(L"Codecevent\n");
			pCodec->HandleEvent(&bEnd);
			if(bEnd) {
				SendMessage(GetDlgItem(hWnd, IDC_MESSAGE), WM_SETTEXT, 0, (long)L"Konvertierung beendet.");
			}
			else
				SendMessage(GetDlgItem(hWnd, IDC_MESSAGE), WM_SETTEXT, 0, (long)L"Konvertierung luft.");

			break;
		case WM_START_CONVERSION:
			
			break;
	}
	return 0;
}
