package meters;
/**
 * Hilfsklasse zur Messung der Aussteuerung
 * @author Michael Steppat
 *
 */
public class LevelMeter {
	/**
	 * Position des Zeigers im Ringpuffer
	 */
	int bufferPos;
	/**
	 * Lnge des Ringpuffers
	 */
	int bufferLength;
	/**
	 * Ringpuffer
	 */
	short buffer[] = null; 
	/**
	 * Summe die aus den Quadratwerten der Samples gebildet wurde 
	 */
	double sum;				
		
	/**
	 * Einstellung der Mittelungszeit (Integrationszeit)
	 * @param time
	 * @param sampleFreq
	 */
	public void SetIntegrationTime(double time, double sampleFreq ){
		if(buffer != null)
			buffer = null;
		bufferLength = (int)(time * sampleFreq);
		buffer = new short[bufferLength];		
	}
	/**
	 * Setzt alle Werte im Puffer auf, den Zeiger und die Summe auf 0 zurck	
	 */
	public void Reset() {
		for (int i = 0; i < bufferLength; i++)
			buffer[i] = 0;
		bufferPos = 0;
		sum = 0;
	}
	/**
	 * Fgt einen neuen Sample dem Puffer hinzu und entfernt den ltesten	
	 * @param sample
	 */
	public void AddSample(short sample) {
		sum -= Math.pow((double)buffer[bufferPos], 2);
		sum += Math.pow((double)sample, 2);
		buffer[bufferPos] = sample;	
		bufferPos++;
		if(bufferPos >= bufferLength)
			bufferPos = 0;
	}
	/**
	 * Gibt den Effektivwert (Mittwert der quadrierten Samplewerte zurck
	 * @return Berechneter Effektivwert
	 */
	public double getRMS() {
		return Math.sqrt(sum / (double)bufferLength);		
	}	

}
